import sys
PIDcodes=[]
def decodeSetPIDcodes(codes):
    global PIDcodes
    PIDcodes=codes
def hex2bin(s):
    i=0
    j=0
    ret=""
    while(i<len(s)):
        #print i, ["%02x"%ord(c) for c in s]
        c=s[i]
        i+=1
        if c.isdigit():
            v=ord(c)-ord('0')
        elif ((c>='A') and (c<='F')):
            v=ord(c)-ord('A')+10
        else:
            continue
        if(j%2):
            ret=ret[0:-1]+chr(ord(ret[-1])|v)
        else:
            ret+=chr(v<<4)
        j+=1
    return ret
#s=hex2bin("41 00 BE 1F B8 11 ")
#print ["%02x"%ord(c) for c in s]

def decodeInt(s, pid, nbytes, low, high, unit):
    v=0
    for i in range(nbytes):
        v=v*256+ord(s[i])
    scaled=low+(high-low)*v/(256**nbytes-1.0)
    return "%.3f %s"%(scaled, unit)

def decodeIntAr(s, pid, nbytesTot, lowAr, highAr, unitAr):
    nbytes=nbytesTot/len(lowAr)
    ret=""
    for (low, high, unit) in range(zip(lowAr, highAr, unitAr)):
        v=0
        for i in range(nbytes):
            v=v*256+ord(s[i])
        scaled=low+(high-low)*v/(256**nbytes-1.0)
        ret+=" %.3f %s"%(scaled, unit)
    return ret


def decodeBits(s, pid, nbytes, bitmap):
    ret=PIDcodes[3]+":"
    for ibit in range(nbyte*8):
        if not bitmap.has_key(ibit):
            continue
        v=(ord(s[ibit/8]<<(ibit%7))&0x80)!=0
        ret+=vitmap[ibit]+": "+str(v+0)
    return ret
def hex2map(s):
    ar=[]
    while(len(s)):
        c=s[0].upper()
        s=s[1:]
        if c.isdigit():
            v=ord(c)-ord('0')
        elif ((c>='A') and (c<='F')):
            v=ord(c)-ord('A')+10
        else:
            continue
        print "V=",v
        for i in range(3,-1,-1):
            print i
            ar.append((v&(1<<i))!=0)
    return ar

def decodeSuppordedPID(s, pid):
    ar=[]
    ret="Supported PIDS:"
    for i in range(0x20):
        ar.append((ord(s[i/8])<<(i%8))&0x80!=0)
    for i in range(0x20):
        if i%8==0:
            #ret+=" [%x]:"%(start+i)
            if i:
                ret+=","
            ret+=" %x-%x:"%(pid+i+1, pid+i+8)
        if i%4==0:
            ret+=" "
        ret+=str(ar[i]+0)
    return ret
def decodeMotorStatus(s, pid):
    ret="Motor Status: Check Engine light:"
    if ord(s[0])&0x80:
        ret+="ON"
    else:
        ret+="OFF"
    ret+=", number of emissions related DTC: %i"%(ord(s[0])&0x7f)
    ret+=", engine: "
    if(ord(s[1])&(1<<3)):
        ret+=" spark ignition"
    else:
        ret+=" compress ignition"
    return ret
def decodeFuelStatus(s, pid):
    ret="Fuel System Status:"
    for i, c in enumerate(s):
        v=ord(c)
        ret+=" system %i: "%(i+1)
        if v&1<<0:
            ret+="Open loop due to insufficient engine temperature"
        if v&1<<1:
            ret+="Closed loop, using oxygen sensor feedback to determine fuel mix"
        if v&1<<2:
            ret+="Open loop due to engine load OR fuel cut due to deceleration"
        if v&1<<3:
            ret+="Open loop due to system failure"
        if v&1<<4:
            ret+="Closed loop, using at least one oxygen sensor but there is a fault in the feedback system"
    return ret

def decodeSecondaryAirStatus(s, pid):
    ret="Commanded secondary air status: "
    for i, c in enumerate(s):
        v=ord(c)
        ret+=" system %i: "%(i+1)
        if v&1<<0:
            ret+="Upstream of catalytic converter"
        if v&1<<1:
            ret+="Downstream of catalytic converter"
        if v&1<<2:
            ret+="From the outside atmosphere or off"
    return ret
def  decodeOBDStandards(s, pid):
    ret="ODB Standards: %x"%(ord(s[0]))
    return ret
def decodeOxygenSensorsPresent(s, pid):
    return "OxygenSensorsPresent: %x"%(ord(s[0]))
def decodeOxygenSensorsPresent1D(s, pid):
    return "OxygenSensorsPresent: %x"%(ord(s[0]))
def decodeOxygenSensorVoltage(s, pid, bank, sensor):
    return "OxygenSensorsVoltage: %x"%(ord(s[0]))

def decodeMonitorStatusThisDriveCycle(s, pid):
    return " %02x %02x %02x %02x"%(ord(s[0]), ord(s[1]), ord(s[2]), ord(s[3]))

def decodeFuelType(s, pid):
    table={
        0x01: 'Gasoline',
        0x02: 'Methanol',
        0x03: 'Ethanol',
        0x04: 'Diesel',
        0x05: 'LPG',
        0x06: 'CNG',
        0x07: 'Propane',
        0x08: 'Electric',
        0x09: 'Bifuel running Gasoline',
        0x0A: 'Bifuel running Methanol',
        0x0B: 'Bifuel running Ethanol',
        0x0C: 'Bifuel running LPG',
        0x0D: 'Bifuel running CNG',
        0x0E: 'Bifuel running Prop',
        0x0F: 'Bifuel running Electricity',
        0x10: 'Bifuel mixed gas/electric',
        0x11: 'Hybrid gasoline',
        0x12: 'Hybrid Ethanol',
        0x13: 'Hybrid Diesel',
        0x14: 'Hybrid Electric',
        0x15: 'Hybrid Mixed fuel',
        0x16: 'Hybrid Regenerative'}
    value=ord(s[0])
    if table.has_key(value):
        return table[value]
    else:
        return "Unknown: %02x"%value

def decodeEmissionReqs(s, pid):
    return "%02x"%(ord(s[0]),)

def decodeErrorCodes(s, pid):

    ret=""
    while len(s)>1:
        if (ord(s[0])+ord(s[1]))==0:
            break
        if(len(ret)):
            ret+=", "
        scode="%02x%02x"%(ord(s[0]),ord(s[1]))
        scode=["P","C","B","U"][ord(s[0])/16]+scode
        ret+=scode
        s=s[2:]
    return ret
#print decodeSuppordedPID(hex2bin("BE 1F B8 11 "), 0)
#print decodeMotorStatus(hex2bin("84 07 61 00"), 0)
#print decodeFuelStatus(hex2bin("02 01"), 0)
