#!/usr/bin/python
import os
import sys
import time
import obdtrace
import re
trace=obdtrace.obdtrace("test-trace.log")
def answerAT(s):
    cmd=s[2:].strip()

    if cmd=="Z":
        return "ELM327 v1.4"
    if cmd=="E0":
        return "OK"
    return "OK"

def loadtrace(filename):
    tracedata={}
    for l in open(filename).readlines():
        #print l
        m=re.match("^\s*([.\d]+)\s*:\s*([\s\da-fA-F]+)\s*:\s*(.+)", l)
        if m==None:
            continue
        times, cmd, resp= m.groups()
        cmd=cmd.upper()
        if not tracedata.has_key(cmd):
            tracedata[cmd]=[]
        tracedata[cmd].append((float(times), resp))
    return tracedata
    #print tracedata

#sys.exit()            

def answerOBD_01(s):
    pid=s[0:2]
    arg=s[2:].strip()
    if pid=="00":
        #return "41 00 BE 1F B8 11"
        #l=[1,3,4,5,6,7,0xC, 0xD,0xE,0xF, 0x10, 0x11,0x13,0x14,0x15,0x1c,0x20]
        l=[1,5,0xc]
        return "41 00" + "%x"%sum([1<<(0x1f/8*8+8-i) for i in l])
    elif pid=="01":
        return "41 01 84 07 61 00"
    elif pid=="05":
        return "41 05 57"
    elif pid=="0C":
        return "41 0C 11 E2"
    else:
        return ""

def answerOBD(s):
    mode=s[0:2]
    cmd=s[2:].strip()
    if mode=="01":
        return answerOBD_01(cmd)
    elif mode=="03":
        return "43 03 00 03 01 03 02\r\n43 13 00 00 00 00 00"
    else:
        return ""

def answerTrace(s, tracedata):
    m=re.match("\s*([\dA-Z][\dA-Z])\s*([\dA-Z][\dA-Z])", s.upper())
    if m==None:
        return ""
    modepid=m.groups()[0]+" "+m.groups()[1]
    if tracedata.has_key(modepid):
        return tracedata[modepid][0][1]
    else:
        return ""

tracedata=loadtrace("ht.log")
while 1:
    s=sys.stdin.readline()
    s=s.strip()
    s=s.upper()
    if not len(s):
        sys.exit()
    trace.log("OBDTEST-read: "+s+", 0:2="+s[0:2])
    if s[0:2]=="AT":
        ret=answerAT(s)
    else:
        #ret=answerOBD(s)
        ret=answerTrace(s, tracedata)
    sys.stdout.write(ret+"\r\n")
    sys.stdout.flush()
    time.sleep(0.1)
    sys.stdout.write(">\r\n")
    sys.stdout.flush()
